-- **** Semaphore ****

CREATE SEQUENCE seq_OP2_SEMAPHORE AS BIGINT START WITH 1 INCREMENT BY 1 ; -- (Scommentare in hsql 2.x) CYCLE;

CREATE TABLE OP2_SEMAPHORE
(
	node_id VARCHAR(255),
	creation_time TIMESTAMP,
	update_time TIMESTAMP,
	details VARCHAR(65535),
	applicative_id VARCHAR(255),
	-- fk/pk columns
	id BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1),
	-- unique constraints
	CONSTRAINT uniq_semaphore_1 UNIQUE (applicative_id),
	-- fk/pk keys constraints
	CONSTRAINT pk_OP2_SEMAPHORE PRIMARY KEY (id)
);

-- index
CREATE UNIQUE INDEX idx_semaphore_1 ON OP2_SEMAPHORE (applicative_id);
CREATE TABLE OP2_SEMAPHORE_init_seq (id BIGINT);
INSERT INTO OP2_SEMAPHORE_init_seq VALUES (NEXT VALUE FOR seq_OP2_SEMAPHORE);


